diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mode.h ns-3.39/src/wifi/model/wifi-mode.h
--- ns-3.38/src/wifi/model/wifi-mode.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mode.h	2023-07-05 14:23:48.121428500 -0700
@@ -31,7 +31,8 @@
 namespace ns3
 {
 
-#define SU_STA_ID 65535
+/// STA_ID to identify a single user (SU)
+static constexpr uint16_t SU_STA_ID = 65535;
 
 class WifiTxVector;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mpdu.cc ns-3.39/src/wifi/model/wifi-mpdu.cc
--- ns-3.38/src/wifi/model/wifi-mpdu.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mpdu.cc	2023-07-05 14:23:48.121428500 -0700
@@ -28,18 +28,18 @@
 
 #include "ns3/log.h"
 #include "ns3/packet.h"
-#include "ns3/simulator.h"
 
 namespace ns3
 {
 
 NS_LOG_COMPONENT_DEFINE("WifiMpdu");
 
-WifiMpdu::WifiMpdu(Ptr<const Packet> p, const WifiMacHeader& header)
+WifiMpdu::WifiMpdu(Ptr<const Packet> p, const WifiMacHeader& header, Time stamp)
     : m_header(header)
 {
     auto& original = std::get<OriginalInfo>(m_instanceInfo);
     original.m_packet = p;
+    original.m_timestamp = stamp;
 
     if (header.IsQosData() && header.IsQosAmsdu())
     {
@@ -115,6 +115,17 @@
     return GetOriginalInfo().m_packet;
 }
 
+Time
+WifiMpdu::GetTimestamp() const
+{
+    if (auto original = std::get_if<ORIGINAL>(&m_instanceInfo))
+    {
+        return original->m_timestamp;
+    }
+    const auto& origInstanceInfo = std::get<Ptr<WifiMpdu>>(m_instanceInfo)->m_instanceInfo;
+    return std::get<OriginalInfo>(origInstanceInfo).m_timestamp;
+}
+
 const WifiMacHeader&
 WifiMpdu::GetHeader() const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-mpdu.h ns-3.39/src/wifi/model/wifi-mpdu.h
--- ns-3.38/src/wifi/model/wifi-mpdu.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-mpdu.h	2023-07-05 14:23:48.121428500 -0700
@@ -28,6 +28,7 @@
 #include "wifi-mac-queue-elem.h"
 
 #include "ns3/packet.h"
+#include "ns3/simulator.h"
 
 #include <list>
 #include <optional>
@@ -64,8 +65,9 @@
      * \brief Create a Wifi MAC queue item containing a packet and a Wifi MAC header.
      * \param p the const packet included in the created item.
      * \param header the Wifi MAC header included in the created item.
+     * \param stamp the timestamp to associate with the MPDU
      */
-    WifiMpdu(Ptr<const Packet> p, const WifiMacHeader& header);
+    WifiMpdu(Ptr<const Packet> p, const WifiMacHeader& header, Time stamp = Simulator::Now());
 
     virtual ~WifiMpdu();
 
@@ -183,6 +185,10 @@
      */
     AcIndex GetQueueAc() const;
     /**
+     * \return the time this MPDU was constructed
+     */
+    Time GetTimestamp() const;
+    /**
      * \return the expiry time of this MPDU
      */
     Time GetExpiryTime() const;
@@ -278,6 +284,7 @@
     struct OriginalInfo
     {
         Ptr<const Packet> m_packet;        //!< MSDU or A-MSDU contained in this queue item
+        Time m_timestamp;                  //!< construction time
         DeaggregatedMsdus m_msduList;      //!< list of aggregated MSDUs included in this MPDU
         std::optional<Iterator> m_queueIt; //!< Queue iterator pointing to this MPDU, if queued
         bool m_seqNoAssigned;              //!< whether a sequence number has been assigned
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-phy.cc ns-3.39/src/wifi/model/wifi-phy.cc
--- ns-3.38/src/wifi/model/wifi-phy.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-phy.cc	2023-07-05 14:23:48.125428400 -0700
@@ -67,6 +67,7 @@
             .SetGroupName("Wifi")
             .AddAttribute("Channel",
                           "The channel attached to this PHY",
+                          TypeId::ATTR_GET,
                           PointerValue(),
                           MakePointerAccessor(&WifiPhy::GetChannel),
                           MakePointerChecker<Channel>())
@@ -88,7 +89,7 @@
                 "number uniquely identify a frequency channel for the given standard and band.",
                 StringValue("{0, 0, BAND_UNSPECIFIED, 0}"),
                 MakeTupleAccessor<UintegerValue, UintegerValue, EnumValue, UintegerValue>(
-                    &WifiPhy::SetOperatingChannel),
+                    (void(WifiPhy::*)(const ChannelTuple&)) & WifiPhy::SetOperatingChannel),
                 MakeTupleChecker<UintegerValue, UintegerValue, EnumValue, UintegerValue>(
                     MakeUintegerChecker<uint8_t>(0, 233),
                     MakeUintegerChecker<uint16_t>(0, 160),
@@ -103,17 +104,20 @@
                     MakeUintegerChecker<uint8_t>(0, 7)))
             .AddAttribute("Frequency",
                           "The center frequency (MHz) of the current operating channel.",
+                          TypeId::ATTR_GET,
                           UintegerValue(0),
                           MakeUintegerAccessor(&WifiPhy::GetFrequency),
                           MakeUintegerChecker<uint16_t>())
             .AddAttribute("ChannelNumber",
                           "The channel number of the current operating channel.",
+                          TypeId::ATTR_GET,
                           UintegerValue(0),
                           MakeUintegerAccessor(&WifiPhy::GetChannelNumber),
                           MakeUintegerChecker<uint8_t>(0, 233))
             .AddAttribute(
                 "ChannelWidth",
                 "The width in MHz of the current operating channel (5, 10, 20, 22, 40, 80 or 160).",
+                TypeId::ATTR_GET,
                 UintegerValue(0),
                 MakeUintegerAccessor(&WifiPhy::GetChannelWidth),
                 MakeUintegerChecker<uint16_t>(5, 160))
@@ -247,6 +251,11 @@
                           PointerValue(),
                           MakePointerAccessor(&WifiPhy::m_postReceptionErrorModel),
                           MakePointerChecker<ErrorModel>())
+            .AddAttribute("InterferenceHelper",
+                          "Ptr to an object that implements the interference helper",
+                          PointerValue(),
+                          MakePointerAccessor(&WifiPhy::m_interference),
+                          MakePointerChecker<InterferenceHelper>())
             .AddAttribute("Sifs",
                           "The duration of the Short Interframe Space. "
                           "NOTE that the default value is overwritten by the value defined "
@@ -1059,6 +1068,17 @@
 }
 
 void
+WifiPhy::SetOperatingChannel(const WifiPhyOperatingChannel& channel)
+{
+    NS_LOG_FUNCTION(this << channel);
+    WifiPhy::ChannelTuple tuple(channel.GetNumber(),
+                                channel.GetWidth(),
+                                channel.GetPhyBand(),
+                                channel.GetPrimaryChannelIndex(20));
+    SetOperatingChannel(tuple);
+}
+
+void
 WifiPhy::SetOperatingChannel(const ChannelTuple& channelTuple)
 {
     // the generic operator<< for tuples does not give a pretty result
@@ -1089,7 +1109,8 @@
     if (delay.IsStrictlyPositive())
     {
         // switching channel has been postponed
-        Simulator::Schedule(delay, &WifiPhy::SetOperatingChannel, this, channelTuple);
+        void (WifiPhy::*fp)(const ChannelTuple&) = &WifiPhy::SetOperatingChannel;
+        Simulator::Schedule(delay, fp, this, channelTuple);
         return;
     }
 
@@ -1118,11 +1139,7 @@
     {
     case WifiPhyState::RX:
         NS_LOG_DEBUG("drop packet because of channel switching while reception");
-        m_endPhyRxEvent.Cancel();
-        for (auto& phyEntity : m_phyEntities)
-        {
-            phyEntity.second->CancelAllEvents();
-        }
+        AbortCurrentReception(CHANNEL_SWITCHING);
         break;
     case WifiPhyState::TX:
         NS_LOG_DEBUG("channel switching postponed until end of current transmission");
@@ -1154,8 +1171,8 @@
     NS_LOG_FUNCTION(this);
 
     // Update unspecified parameters with default values
-    if (auto& [number, width, band, primary20] = m_channelSettings; true)
     {
+        auto& [number, width, band, primary20] = m_channelSettings;
         if (band == static_cast<int>(WIFI_PHY_BAND_UNSPECIFIED))
         {
             band = static_cast<int>(GetDefaultPhyBand(m_standard));
@@ -1218,7 +1235,6 @@
     {
         // notify channel switching
         m_state->SwitchToChannelSwitching(GetChannelSwitchDelay());
-        m_interference->EraseEvents();
         /*
          * Needed here to be able to correctly sensed the medium for the first
          * time after the switching. The actual switching is not performed until
@@ -1835,17 +1851,6 @@
     }
 }
 
-WifiSpectrumBand
-WifiPhy::ConvertHeRuSubcarriers(uint16_t bandWidth,
-                                uint16_t guardBandwidth,
-                                HeRu::SubcarrierRange range,
-                                uint8_t bandIndex) const
-{
-    NS_ASSERT_MSG(false, "802.11ax can only be used with SpectrumWifiPhy");
-    WifiSpectrumBand convertedSubcarriers;
-    return convertedSubcarriers;
-}
-
 void
 WifiPhy::EndReceiveInterBss()
 {
@@ -2083,7 +2088,7 @@
         {
             m_endPhyRxEvent.Cancel();
         }
-        m_interference->NotifyRxEnd(Simulator::Now());
+        m_interference->NotifyRxEnd(Simulator::Now(), GetCurrentFrequencyRange());
         if (!m_currentEvent)
         {
             return;
@@ -2171,15 +2176,6 @@
     return GetPhyEntityForPpdu(ppdu)->GetAddressedPsduInPpdu(ppdu);
 }
 
-WifiSpectrumBand
-WifiPhy::GetBand(uint16_t /*bandWidth*/, uint8_t /*bandIndex*/)
-{
-    WifiSpectrumBand band;
-    band.first = 0;
-    band.second = 0;
-    return band;
-}
-
 int64_t
 WifiPhy::AssignStreams(int64_t stream)
 {
@@ -2204,4 +2200,38 @@
     return m_operatingChannel.GetPrimaryChannelNumber(primaryChannelWidth, m_standard);
 }
 
+uint32_t
+WifiPhy::GetSubcarrierSpacing() const
+{
+    uint32_t subcarrierSpacing = 0;
+    switch (GetStandard())
+    {
+    case WIFI_STANDARD_80211a:
+    case WIFI_STANDARD_80211g:
+    case WIFI_STANDARD_80211b:
+    case WIFI_STANDARD_80211n:
+    case WIFI_STANDARD_80211ac:
+        subcarrierSpacing = 312500;
+        break;
+    case WIFI_STANDARD_80211p:
+        if (GetChannelWidth() == 5)
+        {
+            subcarrierSpacing = 78125;
+        }
+        else
+        {
+            subcarrierSpacing = 156250;
+        }
+        break;
+    case WIFI_STANDARD_80211ax:
+    case WIFI_STANDARD_80211be:
+        subcarrierSpacing = 78125;
+        break;
+    default:
+        NS_FATAL_ERROR("Standard unknown: " << GetStandard());
+        break;
+    }
+    return subcarrierSpacing;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-phy-common.h ns-3.39/src/wifi/model/wifi-phy-common.h
--- ns-3.38/src/wifi/model/wifi-phy-common.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-phy-common.h	2023-07-05 14:23:48.125428400 -0700
@@ -26,6 +26,7 @@
 
 #include "ns3/fatal-error.h"
 #include "ns3/ptr.h"
+#include "ns3/wifi-spectrum-value-helper.h"
 
 #include <ostream>
 
@@ -48,28 +49,114 @@
 class Time;
 
 /**
+ * typedef for a pair of start and stop frequencies in Hz to represent a band
+ */
+using WifiSpectrumBandFrequencies = std::pair<uint64_t, uint64_t>;
+
+/// WifiSpectrumBandInfo structure containing info about a spectrum band
+struct WifiSpectrumBandInfo
+{
+    WifiSpectrumBandIndices indices;         //!< the start and stop indices of the band
+    WifiSpectrumBandFrequencies frequencies; //!< the start and stop frequencies of the band
+};
+
+/**
+ * \ingroup wifi
+ * Compare two bands.
+ *
+ * \param lhs the band on the left of operator<
+ * \param rhs the band on the right of operator<
+ * \return true if the start/stop frequencies of left are lower than the start/stop frequencies of
+ * right, false otherwise
+ */
+inline bool
+operator<(const WifiSpectrumBandInfo& lhs, const WifiSpectrumBandInfo& rhs)
+{
+    return lhs.frequencies < rhs.frequencies;
+}
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param band the band
+ * \returns a reference to the stream
+ */
+inline std::ostream&
+operator<<(std::ostream& os, const WifiSpectrumBandInfo& band)
+{
+    os << "indices: [" << band.indices.first << "-" << band.indices.second << "], frequencies: ["
+       << band.frequencies.first << "Hz-" << band.frequencies.second << "Hz]";
+    return os;
+}
+
+/**
  * These constants define the various convolutional coding rates
  * used for the OFDM transmission modes in the IEEE 802.11
  * standard. DSSS (for example) rates which do not have an explicit
  * coding stage in their generation should have this parameter set to
  * WIFI_CODE_RATE_UNDEFINED.
- * \note This typedef and constants could be converted to an enum or scoped
- * enum if pybindgen is upgraded to support Callback<WifiCodeRate>
  */
-typedef uint16_t WifiCodeRate;
-const uint16_t WIFI_CODE_RATE_UNDEFINED = 0; //!< undefined coding rate
-const uint16_t WIFI_CODE_RATE_1_2 = 1;       //!< 1/2 coding rate
-const uint16_t WIFI_CODE_RATE_2_3 = 2;       //!< 2/3 coding rate
-const uint16_t WIFI_CODE_RATE_3_4 = 3;       //!< 3/4 coding rate
-const uint16_t WIFI_CODE_RATE_5_6 = 4;       //!< 5/6 coding rate
-const uint16_t WIFI_CODE_RATE_5_8 = 5;       //!< 5/8 coding rate
-const uint16_t WIFI_CODE_RATE_13_16 = 6;     //!< 13/16 coding rate
-const uint16_t WIFI_CODE_RATE_1_4 = 7;       //!< 1/4 coding rate
-const uint16_t WIFI_CODE_RATE_13_28 = 8;     //!< 13/28 coding rate
-const uint16_t WIFI_CODE_RATE_13_21 = 9;     //!< 13/21 coding rate
-const uint16_t WIFI_CODE_RATE_52_63 = 10;    //!< 52/63 coding rate
-const uint16_t WIFI_CODE_RATE_13_14 = 11;    //!< 13/14 coding rate
-const uint16_t WIFI_CODE_RATE_7_8 = 12;      //!< 7/8 coding rate
+enum WifiCodeRate : uint16_t
+{
+    WIFI_CODE_RATE_UNDEFINED, //!< undefined coding rate
+    WIFI_CODE_RATE_1_2,       //!< 1/2 coding rate
+    WIFI_CODE_RATE_2_3,       //!< 2/3 coding rate
+    WIFI_CODE_RATE_3_4,       //!< 3/4 coding rate
+    WIFI_CODE_RATE_5_6,       //!< 5/6 coding rate
+    WIFI_CODE_RATE_5_8,       //!< 5/8 coding rate
+    WIFI_CODE_RATE_13_16,     //!< 13/16 coding rate
+    WIFI_CODE_RATE_1_4,       //!< 1/4 coding rate
+    WIFI_CODE_RATE_13_28,     //!< 13/28 coding rate
+    WIFI_CODE_RATE_13_21,     //!< 13/21 coding rate
+    WIFI_CODE_RATE_52_63,     //!< 52/63 coding rate
+    WIFI_CODE_RATE_13_14,     //!< 13/14 coding rate
+    WIFI_CODE_RATE_7_8,       //!< 7/8 coding rate
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param codeRate the code rate
+ * \returns a reference to the stream
+ */
+inline std::ostream&
+operator<<(std::ostream& os, const WifiCodeRate& codeRate)
+{
+    switch (codeRate)
+    {
+    case WIFI_CODE_RATE_UNDEFINED:
+        return (os << "Code rate undefined");
+    case WIFI_CODE_RATE_1_2:
+        return (os << "Code rate 1/2");
+    case WIFI_CODE_RATE_2_3:
+        return (os << "Code rate 2/3");
+    case WIFI_CODE_RATE_3_4:
+        return (os << "Code rate 3/4");
+    case WIFI_CODE_RATE_5_6:
+        return (os << "Code rate 5/6");
+    case WIFI_CODE_RATE_5_8:
+        return (os << "Code rate 5/8");
+    case WIFI_CODE_RATE_13_16:
+        return (os << "Code rate 13/16");
+    case WIFI_CODE_RATE_1_4:
+        return (os << "Code rate 1/4");
+    case WIFI_CODE_RATE_13_28:
+        return (os << "Code rate 13/28");
+    case WIFI_CODE_RATE_13_21:
+        return (os << "Code rate 13/21");
+    case WIFI_CODE_RATE_52_63:
+        return (os << "Code rate 52/63");
+    case WIFI_CODE_RATE_13_14:
+        return (os << "Code rate 13/14");
+    case WIFI_CODE_RATE_7_8:
+        return (os << "Code rate 7/8");
+    default:
+        NS_FATAL_ERROR("Unknown code rate");
+        return (os << "Unknown");
+    }
+}
 
 /**
  * \ingroup wifi
@@ -332,7 +419,7 @@
     PREAMBLE_DETECTION_PACKET_SWITCH,
     FRAME_CAPTURE_PACKET_SWITCH,
     OBSS_PD_CCA_RESET,
-    HE_TB_PPDU_TOO_LATE,
+    PPDU_TOO_LATE,
     FILTERED,
     DMG_HEADER_FAILURE,
     DMG_ALLOCATION_ENDED
@@ -388,8 +475,8 @@
         return (os << "FRAME_CAPTURE_PACKET_SWITCH");
     case OBSS_PD_CCA_RESET:
         return (os << "OBSS_PD_CCA_RESET");
-    case HE_TB_PPDU_TOO_LATE:
-        return (os << "HE_TB_PPDU_TOO_LATE");
+    case PPDU_TOO_LATE:
+        return (os << "PPDU_TOO_LATE");
     case FILTERED:
         return (os << "FILTERED");
     case DMG_HEADER_FAILURE:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-phy.h ns-3.39/src/wifi/model/wifi-phy.h
--- ns-3.38/src/wifi/model/wifi-phy.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-phy.h	2023-07-05 14:23:48.125428400 -0700
@@ -501,6 +501,8 @@
 
     /**
      * Configure the PHY-level parameters for different Wi-Fi standard.
+     * Note that, in case a Spectrum PHY is used, this method must be called after adding
+     * a spectrum channel covering the operating channel bandwidth.
      *
      * \param standard the Wi-Fi standard
      */
@@ -834,7 +836,7 @@
      *
      * \param device the device this PHY is associated with
      */
-    void SetDevice(const Ptr<WifiNetDevice> device);
+    virtual void SetDevice(const Ptr<WifiNetDevice> device);
     /**
      * Return the device this PHY is associated with
      *
@@ -876,10 +878,28 @@
      * Otherwise, set the operating channel based on the given channel settings and
      * call ConfigureStandard if the PHY band has changed.
      *
+     * Note that, in case a Spectrum PHY is used, a spectrum channel covering the
+     * operating channel bandwidth must have been already added when actually setting
+     * the operating channel.
+     *
      * \param channelTuple the given channel settings
      */
     void SetOperatingChannel(const ChannelTuple& channelTuple);
     /**
+     * If the standard for this object has not been set yet, store the channel settings
+     * corresponding to the given operating channel. Otherwise, check if a channel switch
+     * can be performed now. If not, schedule another call to this method when channel switch
+     * can be performed. Otherwise, set the given operating channel and call ConfigureStandard
+     * if the PHY band has changed.
+     *
+     * Note that, in case a Spectrum PHY is used, a spectrum channel covering the
+     * operating channel bandwidth must have been already added when actually setting
+     * the operating channel.
+     *
+     * \param channel the given operating channel
+     */
+    void SetOperatingChannel(const WifiPhyOperatingChannel& channel);
+    /**
      * Configure whether it is prohibited to change PHY band after initialization.
      *
      * \param enable true to prohibit changing PHY band after initialization,
@@ -1034,20 +1054,13 @@
     void NotifyChannelAccessRequested();
 
     /**
-     * \param bandWidth the width (MHz) of the band used for the OFDMA transmission. Must be
-     *                  a multiple of 20 MHz
-     * \param guardBandwidth width of the guard band (MHz)
-     * \param range the subcarrier range of the HE RU
-     * \param bandIndex the index (starting at 0) of the band within the operating channel
-     * \return the converted subcarriers
-     *
-     * This is a helper function to convert HE RU subcarriers, which are relative to the center
-     * frequency subcarrier, to the indexes used by the Spectrum model.
-     */
-    virtual WifiSpectrumBand ConvertHeRuSubcarriers(uint16_t bandWidth,
-                                                    uint16_t guardBandwidth,
-                                                    HeRu::SubcarrierRange range,
-                                                    uint8_t bandIndex = 0) const;
+     * This is a helper function to convert start and stop indices to start and stop frequencies.
+     *
+     * \param indices the start/stop indices to convert
+     * \return the converted frequencies
+     */
+    virtual WifiSpectrumBandFrequencies ConvertIndicesToFrequencies(
+        const WifiSpectrumBandIndices& indices) const = 0;
 
     /**
      * Add the PHY entity to the map of __implemented__ PHY entities for the
@@ -1142,14 +1155,26 @@
     uint8_t GetPrimaryChannelNumber(uint16_t primaryChannelWidth) const;
 
     /**
-     * Get the start band index and the stop band index for a given band
+     * Get the info of a given band
      *
      * \param bandWidth the width of the band to be returned (MHz)
      * \param bandIndex the index of the band to be returned
      *
-     * \return a pair of start and stop indexes that defines the band
+     * \return the info that defines the band
+     */
+    virtual WifiSpectrumBandInfo GetBand(uint16_t bandWidth, uint8_t bandIndex = 0) = 0;
+
+    /**
+     * Get the frequency range of the current RF interface.
+     *
+     * \return the frequency range of the current RF interface
+     */
+    virtual FrequencyRange GetCurrentFrequencyRange() const = 0;
+
+    /**
+     * \return the subcarrier spacing corresponding to the configure standard (Hz)
      */
-    virtual WifiSpectrumBand GetBand(uint16_t bandWidth, uint8_t bandIndex = 0);
+    uint32_t GetSubcarrierSpacing() const;
 
   protected:
     void DoInitialize() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-phy-operating-channel.cc ns-3.39/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.38/src/wifi/model/wifi-phy-operating-channel.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-phy-operating-channel.cc	2023-07-05 14:23:48.125428400 -0700
@@ -695,4 +695,31 @@
     return indices;
 }
 
+bool
+WifiPhyOperatingChannel::operator==(const WifiPhyOperatingChannel& other) const
+{
+    return m_channelIt == other.m_channelIt;
+}
+
+bool
+WifiPhyOperatingChannel::operator!=(const WifiPhyOperatingChannel& other) const
+{
+    return !(*this == other);
+}
+
+std::ostream&
+operator<<(std::ostream& os, const WifiPhyOperatingChannel& channel)
+{
+    if (channel.IsSet())
+    {
+        os << "channel " << +channel.GetNumber() << " in band " << channel.GetPhyBand()
+           << " frequency " << channel.GetFrequency() << " width " << channel.GetWidth();
+    }
+    else
+    {
+        os << "channel not set";
+    }
+    return os;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-phy-operating-channel.h ns-3.39/src/wifi/model/wifi-phy-operating-channel.h
--- ns-3.38/src/wifi/model/wifi-phy-operating-channel.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-phy-operating-channel.h	2023-07-05 14:23:48.125428400 -0700
@@ -64,6 +64,27 @@
 
     virtual ~WifiPhyOperatingChannel();
 
+    /**
+     * Check if the given WifiPhyOperatingChannel is equivalent.
+     * Note that the primary20 channels are not compared.
+     *
+     * \param other another WifiPhyOperatingChannel
+     *
+     * \return true if the given WifiPhyOperatingChannel is equivalent,
+     *         false otherwise
+     */
+    bool operator==(const WifiPhyOperatingChannel& other) const;
+
+    /**
+     * Check if the given WifiPhyOperatingChannel is different.
+     *
+     * \param other another WifiPhyOperatingChannel
+     *
+     * \return true if the given WifiPhyOperatingChannel is different,
+     *         false otherwise
+     */
+    bool operator!=(const WifiPhyOperatingChannel& other) const;
+
     static const std::set<FrequencyChannelInfo>
         m_frequencyChannels; //!< Available frequency channels
 
@@ -281,6 +302,15 @@
                                     subchannel with the lowest center frequency) */
 };
 
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param channel the operating channel
+ * \returns a reference to the stream
+ */
+std::ostream& operator<<(std::ostream& os, const WifiPhyOperatingChannel& channel);
+
 } // namespace ns3
 
 #endif /* WIFI_PHY_OPERATING_CHANNEL_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-ppdu.cc ns-3.39/src/wifi/model/wifi-ppdu.cc
--- ns-3.38/src/wifi/model/wifi-ppdu.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-ppdu.cc	2023-07-05 14:23:48.125428400 -0700
@@ -22,7 +22,7 @@
 #include "wifi-psdu.h"
 
 #include "ns3/log.h"
-#include "ns3/packet.h"
+#include "ns3/wifi-phy-operating-channel.h"
 
 namespace ns3
 {
@@ -31,41 +31,41 @@
 
 WifiPpdu::WifiPpdu(Ptr<const WifiPsdu> psdu,
                    const WifiTxVector& txVector,
-                   uint16_t txCenterFreq,
+                   const WifiPhyOperatingChannel& channel,
                    uint64_t uid /* = UINT64_MAX */)
     : m_preamble(txVector.GetPreambleType()),
       m_modulation(txVector.IsValid() ? txVector.GetModulationClass() : WIFI_MOD_CLASS_UNKNOWN),
-      m_txCenterFreq(txCenterFreq),
+      m_txCenterFreq(channel.IsSet()
+                         ? channel.GetPrimaryChannelCenterFrequency(txVector.GetChannelWidth())
+                         : 0),
       m_uid(uid),
       m_txVector(txVector),
-#ifdef NS3_BUILD_PROFILE_DEBUG
-      m_phyHeaders(Create<Packet>()),
-#endif
+      m_operatingChannel(channel),
       m_truncatedTx(false),
       m_txPowerLevel(txVector.GetTxPowerLevel())
 {
-    NS_LOG_FUNCTION(this << *psdu << txVector << txCenterFreq << uid);
+    NS_LOG_FUNCTION(this << *psdu << txVector << channel << uid);
     m_psdus.insert(std::make_pair(SU_STA_ID, psdu));
 }
 
 WifiPpdu::WifiPpdu(const WifiConstPsduMap& psdus,
                    const WifiTxVector& txVector,
-                   uint16_t txCenterFreq,
+                   const WifiPhyOperatingChannel& channel,
                    uint64_t uid)
     : m_preamble(txVector.GetPreambleType()),
       m_modulation(txVector.IsValid() ? txVector.GetMode(psdus.begin()->first).GetModulationClass()
                                       : WIFI_MOD_CLASS_UNKNOWN),
-      m_txCenterFreq(txCenterFreq),
+      m_txCenterFreq(channel.IsSet()
+                         ? channel.GetPrimaryChannelCenterFrequency(txVector.GetChannelWidth())
+                         : 0),
       m_uid(uid),
       m_txVector(txVector),
-#ifdef NS3_BUILD_PROFILE_DEBUG
-      m_phyHeaders(Create<Packet>()),
-#endif
+      m_operatingChannel(channel),
       m_truncatedTx(false),
       m_txPowerLevel(txVector.GetTxPowerLevel()),
       m_txAntennas(txVector.GetNTx())
 {
-    NS_LOG_FUNCTION(this << psdus << txVector << txCenterFreq << uid);
+    NS_LOG_FUNCTION(this << psdus << txVector << channel << uid);
     m_psdus = psdus;
 }
 
@@ -186,11 +186,7 @@
      *                   â”‚           Channel            â”‚
      *                   â””â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”€â”˜
      */
-    if (minTxFreq >= maxFreq || maxTxFreq <= minFreq)
-    {
-        return false;
-    }
-    return true;
+    return minTxFreq < maxFreq && maxTxFreq > minFreq;
 }
 
 uint64_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-ppdu.h ns-3.39/src/wifi/model/wifi-ppdu.h
--- ns-3.38/src/wifi/model/wifi-ppdu.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-ppdu.h	2023-07-05 14:23:48.125428400 -0700
@@ -40,6 +40,7 @@
 
 class Packet;
 class WifiPsdu;
+class WifiPhyOperatingChannel;
 
 /**
  * Map of const PSDUs indexed by STA-ID
@@ -60,24 +61,24 @@
      *
      * \param psdu the PHY payload (PSDU)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param uid the unique ID of this PPDU
      */
     WifiPpdu(Ptr<const WifiPsdu> psdu,
              const WifiTxVector& txVector,
-             uint16_t txCenterFreq,
+             const WifiPhyOperatingChannel& channel,
              uint64_t uid = UINT64_MAX);
     /**
      * Create a PPDU storing a map of PSDUs.
      *
      * \param psdus the PHY payloads (PSDUs)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param uid the unique ID of this PPDU
      */
     WifiPpdu(const WifiConstPsduMap& psdus,
              const WifiTxVector& txVector,
-             uint16_t txCenterFreq,
+             const WifiPhyOperatingChannel& channel,
              uint64_t uid);
     /**
      * Destructor for WifiPpdu.
@@ -206,10 +207,7 @@
     mutable std::optional<WifiTxVector>
         m_txVector; //!< the TXVECTOR at TX PHY or the reconstructed TXVECTOR at RX PHY (or
                     //!< std::nullopt if TXVECTOR has not been reconstructed yet)
-
-#ifdef NS3_BUILD_PROFILE_DEBUG
-    Ptr<Packet> m_phyHeaders; //!< the PHY headers contained in this PPDU
-#endif
+    const WifiPhyOperatingChannel& m_operatingChannel; //!< the operating channel of the PHY
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-protection.cc ns-3.39/src/wifi/model/wifi-protection.cc
--- ns-3.38/src/wifi/model/wifi-protection.cc	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-protection.cc	2023-07-05 14:23:48.125428400 -0700
@@ -51,7 +51,7 @@
 std::unique_ptr<WifiProtection>
 WifiNoProtection::Copy() const
 {
-    return std::unique_ptr<WifiProtection>(new WifiNoProtection(*this));
+    return std::make_unique<WifiNoProtection>(*this);
 }
 
 void
@@ -72,7 +72,7 @@
 std::unique_ptr<WifiProtection>
 WifiRtsCtsProtection::Copy() const
 {
-    return std::unique_ptr<WifiProtection>(new WifiRtsCtsProtection(*this));
+    return std::make_unique<WifiRtsCtsProtection>(*this);
 }
 
 void
@@ -93,7 +93,7 @@
 std::unique_ptr<WifiProtection>
 WifiCtsToSelfProtection::Copy() const
 {
-    return std::unique_ptr<WifiProtection>(new WifiCtsToSelfProtection(*this));
+    return std::make_unique<WifiCtsToSelfProtection>(*this);
 }
 
 void
@@ -114,7 +114,7 @@
 std::unique_ptr<WifiProtection>
 WifiMuRtsCtsProtection::Copy() const
 {
-    return std::unique_ptr<WifiProtection>(new WifiMuRtsCtsProtection(*this));
+    return std::make_unique<WifiMuRtsCtsProtection>(*this);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/wifi-radio-energy-model.h ns-3.39/src/wifi/model/wifi-radio-energy-model.h
--- ns-3.38/src/wifi/model/wifi-radio-energy-model.h	2023-03-16 20:54:23.868869300 -0700
+++ ns-3.39/src/wifi/model/wifi-radio-energy-model.h	2023-07-05 14:23:48.125428400 -0700
@@ -170,7 +170,7 @@
     ~WifiRadioEnergyModel() override;
 
     /**
-     * \brief Sets pointer to EnergySouce installed on node.
+     * \brief Sets pointer to EnergySource installed on node.
      *
      * \param source Pointer to EnergySource installed on node.
      *
